
Ext.regModel('features', {
	fields: ['content', 'continue','target','type','link'].concat(item_record_fields)
});

App.Feature = Ext.extend(Object, {
	
	getFeaturePanel:function(){
		if(!this.featurePanel)
		{
			this.featurePanel = new Ext.Panel({
				fullscreen:true,
				dockedItems: [{
					xtype: 'toolbar', dock: 'top', scroll: 'horizontal',title:'',
					items:[
					/*{
						xtype:'button',text:'Back',ui:'back',
						handler:function(){
							this.featurePanel.hide();
							backNavigation();
						},
						scope:this
					},*/
					{
						xtype:'spacer'
					},
					{
						xtype:'button',text:'Continue',ui:'action',
						handler:function(){
							var record  = this.getFeatureStore().getAt(0);
							var link = record.get("link");
							
							var target = record.get("target");
							if("itemlist" == target)
							{
							
                                this.featurePanel.hide();
								app.modeldata.getItemList(link);
								panel = app.secondlevel.getSecondLevelPanel();
								panel_stack.push(panel);
								panel.show();
							}
							else if("feature" == target)
							{
                                this.featurePanel.hide();
								app.modeldata.getFeature(link);
								panel = app.feature.getFeaturePanel();
								panel_stack.push(panel);
								panel.show();
							}
							else if("drilldown" == target)
							{
                                this.featurePanel.hide();
								app.modeldata.getDrilldownList(link);
								panel = app.drilldown.getDrilldownPanel();
								panel_stack.push(panel);
								panel.show();
							}
							else if("item" == target)
							{
								//app.modeldata.getItemDetails(link);
								//app.item.getItemPanel().show();
                                window.plugins.childBrowser.showItemDetail(record.get("id"), link, record);
							}
							
						},
						scope:this
					}]
				}],
				layout:{type:'vbox',align:'stretch',pack:'start'},
				items:[
				     //this.getFeatureTitlePanel(),
				     this.getFeatureViewPort()
				 ]
			});
		}
		var name = app.titlename;
		if(name.length>13)
		{
			name = name.substr(0,10)+"...";
		}
		this.featurePanel.getDockedItems()[0].setTitle(name);
		return this.featurePanel;
		
	},

 
	getFeatureTitlePanel: function(){
		return this.featuretitlepanel?this.featuretitlepanel:this.featuretitlepanel=new Ext.Panel({
			height:120,
			items: [
			        {
			        	html: '<img src="./img/second_logo.jpg" />'
			        }
				]
		});
	},
	
	getFeatureViewPort:function(){
		return this.featureviewport?this.featureviewport:this.featureviewport=new Ext.Panel({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        //tpl: new Ext.XTemplate.from('tpl_feature', {compiled: true})
	        html: ''
		}); 
	},
	
	getFeatureStore:function(){
		return this.featureStore?this.featureStore:this.featureStore = new Ext.data.Store({
			model: 'features'
		});
	}

})