App.Modeldata = Ext.extend(Object, {

	loadCategories:function(){
		back_urls = new Array();
		var url = new Array();
		url[0] = content_source + "m/" + channel_id + "/json/category/";
		url[1] = "homepage";
		back_urls.push(url);
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: content_source + "m/" + channel_id + "/json/category/",
			success:function(response,options){
				  var d = Ext.decode(response.responseText);
				  app.main.getTopNewsStore().loadData(d);
				  Ext.getBody().unmask();
			},
			failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	getItemsBycategoryId:function(id){
		
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		var url = content_source + "m/" + channel_id + "/json/category/"+id+"/";
		Ext.Ajax.request({
			url: url,
			success:function(response,options){
				  var	d = Ext.decode(response.responseText);
				  app.secondlevel.getSecondSearchResultStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	getFeatureItemsByURL:function(url){
		
		var url = new Array();
		url[0] = link;
		url[1] = "feature";
		url[2] = app.titlename;
		back_urls.push(url);
		
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: url,
			success:function(response,options){
				  var	d = Ext.decode(response.responseText);
				  app.secondlevel.getSecondSearchResultStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	getFeature:function(link){
		
		var url = new Array();
		url[0] = link;
		url[1] = "feature";
		url[2] = app.titlename;
		back_urls.push(url);
		
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: link,
			success:function(response,options){
				  var d = Ext.decode(response.responseText);				  
				  app.feature.getFeatureStore().loadData(d);
				  app.feature.getFeatureViewPort().update("<div class='item-content' style='padding 10px 5px;'>"+app.feature.getFeatureStore().getAt(0).get("content")+"</div>");
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	loadSearchResults:function(query)
	{		
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		var url = content_source + "m/" + channel_id + "/json/search/q/"+encodeURI(query)+"/";
		Ext.Ajax.request({
			url: url,
			success:function(response,options){
				  var d = Ext.decode(response.responseText);				  
				  app.search.getSearchResultStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	getItemDetails:function(link){
		var url = new Array();
		url[0] = link;
		url[1] = "item";
		url[2] = app.titlename;
		back_urls.push(url);
		app.item.getItemViewPort().update('');
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: link,
			success:function(response,options){
				  var d = Ext.decode(response.responseText);				  
				  app.item.getItemStore().loadData(d);
				  app.item.getItemViewPort().update("<div style='padding 10px 5px;'>"+app.item.getItemStore().getAt(0).get("content")+"</div>");
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	processItemList:function(items) {
		active_record = app.active_record;
		
		for (ind=0; ind<items.length; ind++) {
			item = items[ind];
			
			if (item['target'] && item['target'] != 'item') {
				console.log("Not only items");
				return items;
			}
		}
		if (active_record && active_record.get('subcategories')) {
			active_subcat = null;
			s_rec = null;
			datesubcategory = false;
			
			if (active_record.get('cattype') == 'event') {
				datesubcategory = true;
			}			

			for (subcat in active_record.get('subcategories')) {
				s_rec = active_record.get('subcategories')[subcat];
				if (!s_rec['is_drilldown']) {
					active_subcat = s_rec;
					if (s_rec['is_default']) break;
				}				
			}
			if (!s_rec && !datesubcategory) {
				return items;
			}
			item_tree = new Array();
			others = new Array();
			keys = new Array();
			flat = new Array();
			today = new Date();
			now = new Date(today.getFullYear(), today.getMonth(), today.getDate());
			
			for (ind =0; ind<items.length; ind++) {
				item = items[ind];
				if (datesubcategory && item['dates']) {
					values = item['dates']
														
				}
				else if (s_rec && item['subcat_hash'] != undefined) {
					values = item['subcat_hash'][s_rec['slug']];
				} else {
					values = null;
				}			
				console.log(values);
				if (values && values.length > 0) {
					subcat_values = values.split(",")
					for (vind=0; vind < subcat_values.length; vind++) {
						val = subcat_values[vind];
						if (datesubcategory) {
							dateparts = val.split('-');
							if (dateparts.length != 3) continue;
						
							date = new Date(dateparts[0], dateparts[1], dateparts[2]);
							if (date < now) {continue;}
							val = date.getFullYear() + "-";
							if (date.getMonth() + 1 < 10) val = val + "0";
							val = val + (date.getMonth() + 1) + "-";
							if (date.getDate() + 1 < 10) val = val + "0";
							val = val + (date.getDate() + 1);							
						}
						if (!item_tree[val]) {
							item_tree[val] = new Array();
							keys.push(val);
						}
						item_tree[val].push(item);
					}
				} else {
						others.push(item);
				}
			}
			keys = keys.sort();			
			for (k_ind=0; k_ind < keys.length; k_ind++) {
				key = keys[k_ind];
				for (i_ind=0; i_ind < item_tree[key].length; i_ind++) {	
					item = myclone(item_tree[key][i_ind]);
					item['group_name'] = key;
					flat.push(item);				
				}				
			}
			
			if (others.length > 0) {
				key = keys[k_ind];
				row = new Object();
				row['target'] = 'title';
				row['name'] = 'Other';
				flat.push(row);
				for (i_ind=0; i_ind < others.length; i_ind++) {
					flat.push(others[i_ind]);				
				}												
			}
			return flat;
		} else {
			return items;
		}
		
	},
	
	getItemList:function(link){
		
		var url = new Array();
		url[0] = link;
		url[1] = "itemlist";
		url[2] = app.titlename;
		back_urls.push(url);
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: link,
			success:function(response,options){
				  var d = app.modeldata.processItemList(Ext.decode(response.responseText));
								  
				  app.secondlevel.getSecondSearchResultStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	getDrilldownList:function(link){
		
		var url = new Array();
		url[0] = link;
		url[1] = "drilldown";
		url[2] = app.titlename;
		back_urls.push(url);
		
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		console.log(link);
		Ext.Ajax.request({
			url: link,
			success:function(response,options){
				  var d = app.modeldata.processItemList(Ext.decode(response.responseText));
				  app.drilldown.getDrilldownStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
	},
	
	getFavorites:function()
	{
		favorites = storage.getItem("favorites");
		if (!favorites) {
			favorites = "[]";
		}
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: content_source + 'm/' + channel_id + '/json/itemlist/?q=' + favorites,
			success:function(response,options){
				  var d = Ext.decode(response.responseText);
				  app.secondlevel.getSecondSearchResultStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
		
	},
	
	getSocials:function()
	{		
		var link = content_source + "m/" + channel_id + "/json/twitter/";
		loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Loading...", store:this.secondsearchResultStore});
		loadMask.show();
		Ext.Ajax.request({
			url: link,
			success:function(response,options){
				  var text = response.responseText;
				  var text2 = text.replace("'", "\'");
				  var d = Ext.decode(text2);
				  app.social.getSocialStore().loadData(d);
				  Ext.getBody().unmask();
			},
	        failure: function(response, options){
	            Ext.getBody().unmask();
	            Ext.Msg.alert('', 'No response from server!', Ext.emptyFn);
	        }
		});
		
	}
	
	
	
})