
App.ThirdLevel = Ext.extend(Object, {
	
	getThirdLevelPanel:function(){
		if(!this.thirdLevelPanel)
		{
			this.thirdLevelPanel = new Ext.Panel({
				fullscreen:true,
				dockedItems: [{
					xtype: 'toolbar', dock: 'top', scroll: 'horizontal',title:'Bloggers',
					items:[{
						xtype:'button',text:'Back',ui:'back',
						handler:function(){
							this.thirdLevelPanel.hide();
							app.secondlevel.getSecondLevelPanel().show();
						},
						scope:this
					}]
				}],
				layout:{type:'vbox',align:'stretch',pack:'start'},
				items:[
				     this.getThirdTitlePanel(),
				     this.getThirdViewPort()
				 ]
			});
		}
		
		return this.thirdLevelPanel;
		
	},

 
	getThirdTitlePanel: function(){
		return this.thirdtitlepanel?this.thirdtitlepanel:this.thirdtitlepanel=new Ext.Panel({
			height:120,
			items: [
			        {
			        	html: '<img src="./img/second_logo.jpg" />'
			        }
				]
		});
	},
	
	getThirdViewPort:function(){
		return this.thirdviewport?this.thirdviewport:this.thirdviewport=new Ext.List({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        monitorResize : true,
	        singleSelect: true,
	        store: this.getThirdSearchResultStore(),
	        itemTpl: new Ext.XTemplate.from('secondlist', {compiled: true}),
	        itemSelector: 'div.contact',
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					app.secondlevelRecord = record;
					app.fourthlevel.getFourthLevelPanel().show();
					app.thirdlevel.getThirdLevelPanel().hide();
				}
			}
		}); 
	},
	
	getThirdSearchResultStore:function(){
		return this.thirdsearchResultStore?this.thirdsearchResultStore:this.thirdsearchResultStore = new Ext.data.Store({
			model: 'news',
			data: [
			       {id: '1', name:'Am I liable for what commenters...'},
			       {id: '2', name:'Can I be sued by people I...'},
			       {id: '3', name:'Can I blog anonymously?'},
			       {id: '4', name:'Can I copy content from other...'},
			       {id: '5', name:'The Corrections : guide to...'}
			      ]
		});
	}

})