
Ext.regModel('drilldowns', {
	fields: ['link', 'target'].concat(item_record_fields)
});

App.Drilldown = Ext.extend(Object, {
	
	getDrilldownPanel:function(){
	
/*		if(!this.drilldownPanel)
		{	*/	
			this.drilldownPanel = new Ext.Panel({
				fullscreen:true,
				dockedItems: [{
					xtype: 'toolbar', dock: 'top', scroll: 'horizontal',title:'',
					items:[/*{
						xtype:'button',text:'Back',ui:'back',
						handler:function(){
							this.drilldownPanel.hide();
							backNavigation();
						},
						scope:this
					}*/]
				}],
				layout:{type:'vbox',align:'stretch',pack:'start'},
				items:[
				     this.getDrilldownTitlePanel(),
				     this.getDrilldownViewPort()
				 ]
			});
		/*}*/
		var name = app.titlename;
		/*if(name.length>13)
		{
			name = name.substr(0,10)+"...";
		}*/
		this.drilldownPanel.getDockedItems()[0].setTitle(name);
		return this.drilldownPanel;
		
	},

 
	getDrilldownTitlePanel: function(){
		if (!app.header_image) {
		    return new Ext.Panel();
		} else {
			return new Ext.Panel({
				height:app.active_record.get('header_height'),
				items: [
				        {
			    	    	html: '<img src="' + app.header_image + '" />'
			        	}
					]
				});
		}
	},
	
	getDrilldownViewPort:function(){
		return this.drilldownviewport?this.drilldownviewport:this.drilldownviewport=new Ext.List({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        monitorResize : true,
	        singleSelect: true,
	        store: this.getDrilldownStore(),
	        itemTpl: new Ext.XTemplate.from('tpl_drilldownlist', {compiled: true}),
	        itemSelector: 'div.contact',
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					app.titlename = record.get("name");
					var target = record.get("target");
					var link = record.get("link");
					
					if("item" == target)
					{
                        window.plugins.childBrowser.showItemDetail(record.get("id"), link, record);                                      
					}
					else if("drilldown"==target)
					{
						app.modeldata.getDrilldownList(link);
						panel = app.drilldown.getDrilldownPanel();
						panel.show();
						panel_stack.push(panel);
					}else if("itemlist"==target)
					{
						app.modeldata.getItemList(link);
						panel = app.secondlevel.getSecondLevelPanel();
						panel.show();
						panel_stack.push(panel);
					}
				}
			}
		}); 
	},
	
	getDrilldownStore:function(){
		return this.drilldownStore?this.drilldownStore:this.drilldownStore = new Ext.data.Store({
			model: 'drilldowns'
		});
	}

})