Ext.regModel('favorites', {
	fields: ['link'].concat(item_record_fields)	
});

App.Favorites = Ext.extend(Object, {
	
	getFavoritesPanel:function(){
		return this.favoritesPanel?this.favoritesPanel:this.favoritesPanel=new Ext.Panel({
			dockedItems: [{
				xtype: 'toolbar', 
				dock: 'top', 
				title:'Favorites'
			}],
			iconCls: 'favorites', 
			title: 'Favorites',
			layout:'fit',
			listeners:{
         			activate : function(panel){         				
            			app.modeldata.getFavorites();
         			}
      		},
			items:[
			  /*{
			    html: 'Favorites Records List'   
			  }*/
			  this.getFavoritesViewPort()
			]
		});
	},
	
	getFavoritesViewPort:function(){
		return this.favoritesviewport?this.favoritesviewport:this.favoritesviewport=new Ext.List({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        monitorResize : true,
	        singleSelect: true,
	        store: app.secondlevel.getSecondSearchResultStore(),
	        itemTpl: new Ext.XTemplate.from('secondlist', {compiled: true}),
	        itemSelector: 'div.contact',
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					var target = record.get("target");
					var link = record.get("link");
					app.titlename = record.get("name");
					
					if("item" == target)
					{
						//app.secondlevel.getSecondLevelPanel().hide()
						//app.modeldata.getItemDetails(link);
						//app.item.getItemPanel().show();
                        window.plugins.childBrowser.showItemDetail(record.get("id"), link, record);
					}
				}
			}
		}); 
	},
	
	getFavoritesStore:function(){
		return this.favoritesStore?this.favoritesStore:this.favoritesStore = new Ext.data.Store({
			model: 'favorites'
		});
	},

	addFavorite:function(itemId){
		
		
		favorites = storage.getItem("favorites");
		
		if (!favorites) {
			favorites = new Array();
		} else {
			favorites = JSON.parse(favorites);
		}
		
		favorites.push(itemId);
		
		storage.setItem("favorites", JSON.stringify(favorites));		
	}



})