
Ext.regModel('items', {
	fields: ['content']
});

App.Item = Ext.extend(Object, {
	
	getItemPanel:function(){
		if(!this.itemPanel)
		{
			this.itemPanel = new Ext.Panel({
				fullscreen:true,
				dockedItems: [{
					xtype: 'toolbar', dock: 'top', scroll: 'horizontal',title:'',
					items:[{
							xtype:'button',text:'Back',ui:'back',
							handler:function(){
								this.itemPanel.hide();
								app.isfavorites = false;
								backNavigation();
							},
							scope:this
						},
						{
							xtype:'spacer'
						},
						{ 
							xtype:'button',id:'item_favorites', text:'Remove',ui:'action',
							handler:function(){
								var value = storage.getItem("favorites");
								if(value==null)
								{
									value="";
								}
								var len = back_urls.length;
								var arr = back_urls[len-1];//get current item information
									
								var replace  = arr[2]+";"+arr[0]+"|";
								var newvalue = value.replace(replace, "");
								storage.setItem("favorites", newvalue);
								alert("Remove The Item From Favorites Success");
								app.modeldata.getFavorites();
								app.isfavorites = false;
								Ext.getCmp("item_favorites").setVisible(false);
								Ext.getCmp("button_favorites").	setDisabled(false);
							} 
						}/*,
						{ 
							iconMask: true, ui: 'plain', iconCls: 'add',
							handler:function(){
								alert("2");
							} 
						}*/]
					},
					{
						xtype: 'toolbar', dock: 'bottom', scroll: 'horizontal',title:'',
						layout: {
							type: 'hbox',
			                pack: 'center'
				        },
						items:[
							{ 
								  iconMask: true, 
								  id: 'button_favorites', 
								  ui: 'plain', 
								  iconCls: 'favorites2',
								  handler: function()
								  {
								  		var value = storage.getItem("favorites");
										if(value==null)
										{
											value="";
										}
										var len = back_urls.length;
										var arr = back_urls[len-1];//get current item information
										value = value+arr[2]+";"+arr[0]+"|";
										storage.setItem("favorites", value);
										alert("Add The Item into Favorites Success");
										app.modeldata.getFavorites();
										app.isfavorites = false;
										Ext.getCmp("button_favorites").	setDisabled(true);
										Ext.getCmp("item_favorites").setVisible(true);
										Ext.getCmp("item_favorites").setText("Remove");
								  }
						    },
							{ 
								  iconMask: true, 
								  ui: 'plain', 
								  iconCls: 'users2',
								  handler: function()
								  {
								  	var len = back_urls.length;
									var arr = back_urls[len-1];
									var subject = arr[2];
									var body = arr[0];
								  	window.location.href="mailto:user@mail.com?subject="+subject+"&body="+body;
								  }
						 	}
						]
					}],
				layout:{type:'vbox',align:'stretch',pack:'start'},
				items:[
				     //this.getItemTitlePanel(),
				     this.getItemViewPort()
				 ]
			});
		}
		var name = app.titlename;
		if(name.length>13)
		{
			name = name.substr(0,10)+"...";
		}
		this.itemPanel.getDockedItems()[0].setTitle(name);
		if(app.isfavorites==true)
		{
			//this.itemPanel.getDockedItems()[0].items[2].setText("Remove");
			//Ext.getCmp("item_favorites").setText("Remove");
			Ext.getCmp("item_favorites").setVisible(true);
			Ext.getCmp("button_favorites").	setDisabled(true);
		}
		else
		{
			//this.itemPanel.getDockedItems()[0].items[2].setText("Add");
			//Ext.getCmp("item_favorites").setText("Add");
			Ext.getCmp("item_favorites").setVisible(false);
			Ext.getCmp("button_favorites").	setDisabled(false);
		}
		
		return this.itemPanel;
		
	},

 
	getItemTitlePanel: function(){
		return this.itemtitlepanel?this.itemtitlepanel:this.itemtitlepanel=new Ext.Panel({
			height:120,
			items: [
			        {
			        	html: '<img src="./img/second_logo.jpg" />'
			        }
				]
		});
	},
	
	getItemViewPort:function(){
		if( !this.itemviewport)
		{
			this.itemviewport=new Ext.Panel({
				flex:1,
				style:'background-color:#A9A9A9',
				id: 'itemviewport',
				scroll:'vertical',
				styleHtmlContent: true,
				//stopMaskTapEvent: false,
				//hideOnMaskTap: false,
		        //html: '<html><body><a href="http://www.baidu.com"> baidu </a></body></html>',
		        html: '',
		        listeners:{
			        afterrender: function(obj)
					{
						//var itemdetail = document.getElementById("itemviewport");
						obj.mon(obj.el, {
			                tap: function(e,t){
			                	if(t.href)
								{
									window.plugins.childBrowser.showWebPage(t.href,true);
								}
			                },
			                scope: this
			            });
					}
				}
			}); 
		
		  /*
			this.itemviewport.mon(this.itemviewport.el, {
                tap: function(e,t){
                	if(t.href)
					{
						window.plugins.childBrowser.showWebPage(t.href,true);
					}
                },
                scope: this
            });
            
         
            this.itemviewport.body.on('tap', function(e, t) {
				//document.location.href = t.href;
				if(t.href)
				{
					window.plugins.childBrowser.showWebPage(t.href,true);
				}
			}, null, {delegate: 'a'});
			
			
            this.itemviewport.body.on('tap', function(e, t) {
				//document.location.href = t.href;
				if(t.href)
				{
					window.plugins.childBrowser.showWebPage(t.href,true);
				}
			});*/
		}
		return this.itemviewport;
	},
	
	getItemStore:function(){
		return this.itemStore?this.itemStore:this.itemStore = new Ext.data.Store({
			model: 'items'
		});
	}

})