
Ext.regModel('items', {
	fields: ['id','name','tester','content_url']
});

App.SecondLevel = Ext.extend(Object, {
	
	getSecondLevelPanel:function(){

			this.secondLevelPanel = new Ext.Panel({
				fullscreen:true,
				dockedItems: [{
					xtype: 'toolbar', dock: 'top', scroll: 'horizontal',title:'',
					items:[]
				}],
				layout:{type:'vbox',align:'stretch',pack:'start'},
				items:[
				     this.getSecondTitlePanel(),
				     this.getSecondViewPort()
				 ]
			});

		var name = app.titlename;
		/*if(name.length>13)
		{
			name = name.substr(0,10)+"...";
		}*/
		this.secondLevelPanel.getDockedItems()[0].setTitle(name);
		return this.secondLevelPanel;
		
	},

 
	getSecondTitlePanel: function(){
		if (!app.header_image) {
		    return new Ext.Panel();
		} else {
			return new Ext.Panel({
				height:app.active_record.get('header_height'),
				items: [
				        {
			    	    	html: '<img src="' + app.header_image + '" />'
			        	}
					]
				});
		}
	},
	
	getSecondViewPort:function(){
		return this.secondviewport?this.secondviewport:this.secondviewport=new Ext.List({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        monitorResize : true,
	        singleSelect: true,
	        store: this.getSecondSearchResultStore(),
	        itemTpl: App.mainTpl,
	        itemSelector: 'div.contact',
	        
	        grouped:true,
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					var target = record.get("target");
					var link = record.get("link");
					app.titlename = record.get("name");
					
					if("item" == target)
					{
                        window.plugins.childBrowser.showItemDetail(record.get("id"), link, record);
					}
					else if("itemlist"==target)
					{
						app.modeldata.getItemList(link);
						panel = app.secondlevel.getSecondLevelPanel();
						panel.show();
						panel_stack.push(panel);
					}

				}
			}
		}); 
	},
	
	getSecondSearchResultStore:function(){
		if (!this.secondsearchResultStore) {
			this.secondsearchResultStore = new Ext.data.Store({
				model: 'items',
				getGroupString: function(record) { if (record.get('group_name')) {return record.get('group_name')} else {return ""}},
			});
			//loadMask = new Ext.LoadMask(Ext.getBody(), {msg:"Please wait...", store:this.secondsearchResultStore});
		}
		
		return this.secondsearchResultStore;
	}

})