
Ext.regModel('socials', {
	fields: ['user','text']
});

App.Social = Ext.extend(Object, {
	
	getSocialPanel:function(){
		return this.socialPanel?this.socialPanel:this.socialPanel=new Ext.Panel({
			dockedItems: [{
				xtype: 'toolbar', 
				dock: 'top', 
				title:'Social'
			}],
			iconCls: 'team', 
			title: 'Social',
			layout:'fit',
			items:[

			  this.getSocialViewPort()
			]
		});
	},
	
	getSocialViewPort:function(){
		return this.socialviewport?this.socialviewport:this.socialviewport=new Ext.List({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        monitorResize : true,
	        singleSelect: true,
	        emptyText: 'No Data Found',
	        store: this.getSocialStore(),
	        itemTpl: new Ext.XTemplate.from('tpl_socialist', {compiled: true}),
	        itemSelector: 'div.contact',
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					var user = record.get("user");
					app.titlename = user.name;
					var link = user.url;
					window.plugins.childBrowser.showWebPage(link,true);
				},
				afterrender: function (obj)
				{
					app.modeldata.getSocials();
				}
			}
		}); 
	},
	
	getSocialStore:function(){
		return this.socialStore?this.socialStore:this.socialStore = new Ext.data.Store({
			model: 'socials'
		});
	}
	

})